.\"	$NetBSD: bge.4,v 1.11 2009/09/26 04:51:21 elad Exp $
.\"
.\" Copyright (c) 2003 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Matthias Scheler <tron@NetBSD.org>.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd September 26, 2009
.Dt BGE 4
.Os
.Sh NAME
.Nm bge
.Nd Broadcom BCM570x family Gigabit Ethernet driver
.Sh SYNOPSIS
.Cd "bge* at pci? dev ? function ?"
.Pp
Configuration of PHYs may also be necessary.
See
.Xr mii 4 .
.Sh DESCRIPTION
The
.Nm
device driver supports Gigabit Ethernet interfaces based on the Broadcom
BCM570x family of Gigabit Ethernet chips and the BCM5906 chip.
The interfaces supported by the
.Nm
driver include:
.Bl -bullet
.It
3Com 3c996-T (10BASE-T/100BASE-TX/1000BASE-T)
.It
Dell PowerEdge 2550 integrated BCM5700 NIC (10BASE-T/100BASE-TX/1000BASE-T)
.It
IBM x235 server integrated BCM5703x NIC (10BASE-T/100BASE-TX/1000BASE-T)
.It
Netgear GA302T (10BASE-T/100BASE-TX/1000BASE-T)
.It
SysKonnect SK-9D21 (10BASE-T/100BASE-TX/1000BASE-T)
.It
SysKonnect SK-9D41 (1000BASE-SX)
.El
.Pp
The BCM570x family supports IPv4/TCP/UDP checksumming in hardware.
The
.Nm
driver supports this feature of the chip.
See
.Xr ifconfig 8
for information on how to enable this feature.
.Pp
The level of interrupt mitigation for received packets can be adjusted
with the
.Li hw.bge.rx_lvl
.Xr sysctl 8
control.
A value of 1 yields a
.Nm
interrrupt for every two full-sized Ethernet frames.
Each increment of the value will, roughly, halve receive interrupt rate,
up to a maximum of 5, which interrupts about every 30 to 40 full-sized
TCP segments.
.Sh SEE ALSO
.Xr arp 4 ,
.Xr bce 4 ,
.Xr ifmedia 4 ,
.Xr mii 4 ,
.Xr netintro 4 ,
.Xr pci 4 ,
.Xr ifconfig 8
.Sh HISTORY
The
.Nm
driver first appeared in
.Nx 1.6.1 .
.Sh AUTHORS
.An -nosplit
The
.Nm
driver was written by
.An Bill Paul
.Aq wpaul@windriver.com
for
.Fx
and ported to
.Nx
by
.An Frank van der Linden
.Aq fvdl@wasabisystems.com ,
.An Jason R. Thorpe
.Aq thorpej@wasabisystems.com
and
.An Jonathan Stone
.Aq jonathan@dsg.stanford.edu .
